/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse knparse
#define yylex   knlex
#define yyerror knerror
#define yylval  knlval
#define yychar  knchar
#define yydebug kndebug
#define yynerrs knnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TRUE = 258,
     FALSE = 259,
     NUM = 260,
     FLOAT = 261,
     STRING = 262,
     VARIABLE = 263,
     OPENPAREN = 264,
     CLOSEPAREN = 265,
     EQQ = 266,
     COMMA = 267,
     ACTSTR = 268,
     LOCINI = 269,
     KOF = 270,
     KEYPRE = 271,
     KNVERSION = 272,
     DOTT = 273,
     SIGNERKEY = 274,
     HINT = 275,
     OPENBLOCK = 276,
     CLOSEBLOCK = 277,
     SIGNATUREENTRY = 278,
     PRIVATEKEY = 279,
     SEMICOLON = 280,
     REGEXP = 281,
     GE = 282,
     LE = 283,
     GT = 284,
     LT = 285,
     NE = 286,
     EQ = 287,
     OR = 288,
     AND = 289,
     NOT = 290,
     MINUS = 291,
     PLUS = 292,
     MOD = 293,
     DIV = 294,
     MULT = 295,
     EXP = 296,
     OPENFLT = 297,
     OPENNUM = 298,
     DEREF = 299,
     UNARYMINUS = 300
   };
#endif
/* Tokens.  */
#define TRUE 258
#define FALSE 259
#define NUM 260
#define FLOAT 261
#define STRING 262
#define VARIABLE 263
#define OPENPAREN 264
#define CLOSEPAREN 265
#define EQQ 266
#define COMMA 267
#define ACTSTR 268
#define LOCINI 269
#define KOF 270
#define KEYPRE 271
#define KNVERSION 272
#define DOTT 273
#define SIGNERKEY 274
#define HINT 275
#define OPENBLOCK 276
#define CLOSEBLOCK 277
#define SIGNATUREENTRY 278
#define PRIVATEKEY 279
#define SEMICOLON 280
#define REGEXP 281
#define GE 282
#define LE 283
#define GT 284
#define LT 285
#define NE 286
#define EQ 287
#define OR 288
#define AND 289
#define NOT 290
#define MINUS 291
#define PLUS 292
#define MOD 293
#define DIV 294
#define MULT 295
#define EXP 296
#define OPENFLT 297
#define OPENNUM 298
#define DEREF 299
#define UNARYMINUS 300




/* Copy the first part of user declarations.  */


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 20 "keynote.y"
{
    char   *string;
    double  doubval;
    int     intval;
    int     bool;
}
/* Line 187 of yacc.c.  */
#line 202 "k.tab.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */
#line 44 "keynote.y"

#if HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <math.h>

#if STDC_HEADERS
#include <string.h>
#endif /* STDC_HEADERS */

#include "header.h"
#include "keynote.h"
#include "assertion.h"

static int *keynote_kth_array = (int *) NULL;
static int keylistcount = 0;

static int   resolve_assertion(char *);
static int   keynote_init_kth(void);
static int   isfloatstring(char *);
static int   checkexception(int);
static char *my_lookup(char *);
static int   intpow(int, int);
static int   get_kth(int);


/* Line 216 of yacc.c.  */
#line 245 "k.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  16
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   247

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  46
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  36
/* YYNRULES -- Number of rules.  */
#define YYNRULES  96
/* YYNRULES -- Number of states.  */
#define YYNSTATES  172

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   300

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     8,     9,    13,    14,    18,    19,
      23,    24,    28,    29,    33,    34,    38,    39,    41,    43,
      45,    46,    51,    52,    57,    61,    62,    63,    70,    72,
      76,    78,    79,    81,    85,    86,    92,    94,    95,    96,
     101,   105,   107,   109,   113,   117,   118,   123,   124,   129,
     132,   134,   136,   138,   140,   142,   146,   150,   154,   158,
     162,   166,   170,   174,   178,   182,   186,   190,   194,   198,
     202,   206,   209,   213,   215,   218,   222,   226,   230,   234,
     238,   241,   245,   247,   250,   254,   258,   262,   266,   270,
     274,   278,   282,   284,   286,   290,   292
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      47,     0,    -1,    -1,    14,    48,    64,    -1,    -1,    13,
      49,    67,    -1,    -1,    16,    50,    55,    -1,    -1,    19,
      51,    63,    -1,    -1,    23,    52,    63,    -1,    -1,    17,
      53,     7,    -1,    -1,    24,    54,     7,    -1,    -1,    56,
      -1,    63,    -1,    57,    -1,    -1,    56,    34,    58,    56,
      -1,    -1,    56,    33,    59,    56,    -1,     9,    57,    10,
      -1,    -1,    -1,    15,    60,     9,    61,    62,    10,    -1,
      63,    -1,    63,    12,    62,    -1,    80,    -1,    -1,    65,
      -1,     8,    11,     7,    -1,    -1,     8,    11,     7,    66,
      65,    -1,    68,    -1,    -1,    -1,    70,    69,    25,    68,
      -1,    72,    20,    71,    -1,    72,    -1,    80,    -1,    21,
      68,    22,    -1,     9,    72,    10,    -1,    -1,    72,    34,
      73,    72,    -1,    -1,    72,    33,    74,    72,    -1,    35,
      72,    -1,    75,    -1,    76,    -1,    79,    -1,     3,    -1,
       4,    -1,    77,    30,    77,    -1,    77,    29,    77,    -1,
      77,    32,    77,    -1,    77,    28,    77,    -1,    77,    27,
      77,    -1,    77,    31,    77,    -1,    78,    30,    78,    -1,
      78,    29,    78,    -1,    78,    28,    78,    -1,    78,    27,
      78,    -1,    77,    37,    77,    -1,    77,    36,    77,    -1,
      77,    40,    77,    -1,    77,    39,    77,    -1,    77,    38,
      77,    -1,    77,    41,    77,    -1,    36,    77,    -1,     9,
      77,    10,    -1,     5,    -1,    43,    81,    -1,    78,    37,
      78,    -1,    78,    36,    78,    -1,    78,    40,    78,    -1,
      78,    39,    78,    -1,    78,    41,    78,    -1,    36,    78,
      -1,     9,    78,    10,    -1,     6,    -1,    42,    81,    -1,
      80,    32,    80,    -1,    80,    31,    80,    -1,    80,    30,
      80,    -1,    80,    29,    80,    -1,    80,    28,    80,    -1,
      80,    27,    80,    -1,    80,    26,    80,    -1,    80,    18,
      80,    -1,    81,    -1,     7,    -1,     9,    80,    10,    -1,
       8,    -1,    44,    80,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    76,    76,    76,    78,    78,    79,    79,    81,    81,
      82,    82,    84,    84,    90,    90,    96,    99,   104,   105,
     108,   108,   117,   117,   126,   127,   127,   127,   146,   154,
     164,   203,   204,   207,   242,   241,   277,   283,   284,   284,
     299,   306,   315,   328,   331,   332,   332,   337,   337,   342,
     343,   344,   345,   346,   347,   350,   351,   352,   353,   354,
     355,   358,   359,   360,   361,   364,   365,   366,   367,   375,
     383,   384,   385,   386,   387,   403,   404,   405,   406,   414,
     418,   419,   420,   421,   438,   450,   462,   474,   486,   498,
     510,   600,   624,   627,   628,   629,   655
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TRUE", "FALSE", "NUM", "FLOAT",
  "STRING", "VARIABLE", "OPENPAREN", "CLOSEPAREN", "EQQ", "COMMA",
  "ACTSTR", "LOCINI", "KOF", "KEYPRE", "KNVERSION", "DOTT", "SIGNERKEY",
  "HINT", "OPENBLOCK", "CLOSEBLOCK", "SIGNATUREENTRY", "PRIVATEKEY",
  "SEMICOLON", "REGEXP", "GE", "LE", "GT", "LT", "NE", "EQ", "OR", "AND",
  "NOT", "MINUS", "PLUS", "MOD", "DIV", "MULT", "EXP", "OPENFLT",
  "OPENNUM", "DEREF", "UNARYMINUS", "$accept", "grammarswitch", "@1", "@2",
  "@3", "@4", "@5", "@6", "@7", "keypredicate", "notemptykeypredicate",
  "keyexp", "@8", "@9", "@10", "@11", "keylist", "key", "localinit",
  "localconstants", "@12", "program", "prog", "@13", "notemptyprog",
  "afterhint", "expr", "@14", "@15", "numexp", "floatexp", "numex",
  "floatex", "stringexp", "str", "strnotconcat", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    46,    48,    47,    49,    47,    50,    47,    51,    47,
      52,    47,    53,    47,    54,    47,    55,    55,    56,    56,
      58,    57,    59,    57,    57,    60,    61,    57,    62,    62,
      63,    64,    64,    65,    66,    65,    67,    68,    69,    68,
      70,    70,    71,    71,    72,    73,    72,    74,    72,    72,
      72,    72,    72,    72,    72,    75,    75,    75,    75,    75,
      75,    76,    76,    76,    76,    77,    77,    77,    77,    77,
      77,    77,    77,    77,    77,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    79,    79,    79,    79,    79,    79,
      79,    80,    80,    81,    81,    81,    81
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     3,     0,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     1,     1,     1,
       0,     4,     0,     4,     3,     0,     0,     6,     1,     3,
       1,     0,     1,     3,     0,     5,     1,     0,     0,     4,
       3,     1,     1,     3,     3,     0,     4,     0,     4,     2,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     1,     2,     3,     3,     3,     3,     3,
       2,     3,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     3,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     4,     2,     6,    12,     8,    10,    14,     0,    37,
      31,    16,     0,     0,     0,     0,     1,    53,    54,    73,
      82,    93,    95,     0,     0,     0,     0,     0,     0,     5,
      36,    38,    41,    50,    51,     0,     0,    52,     0,    92,
       0,     3,    32,     0,    25,     7,    17,    19,    18,    30,
      13,     0,     9,    11,    15,     0,     0,     0,     0,    49,
       0,    71,    80,    83,    74,    96,     0,     0,    47,    45,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    19,    30,     0,    22,    20,     0,    44,    72,    81,
      94,     0,     0,    37,    37,    40,    42,     0,     0,     0,
       0,    59,    58,    56,    55,    60,    57,    66,    65,    69,
      68,    67,    70,     0,     0,    64,    63,    62,    61,    76,
      75,    78,    77,    79,    91,    90,    89,    88,    87,    86,
      85,    84,    33,    24,    26,     0,     0,    39,     0,    48,
      46,     0,     0,    23,    21,    43,    35,     0,    28,    27,
       0,    29
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     8,    10,     9,    11,    13,    14,    12,    15,    45,
      46,    47,   156,   155,   103,   162,   167,    48,    41,    42,
     161,    29,    30,    66,    31,   115,    32,   118,   117,    33,
      34,    35,    36,    37,    49,    39
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -42
static const yytype_int16 yypact[] =
{
     115,   -42,   -42,   -42,   -42,   -42,   -42,   -42,    10,    20,
      -4,   111,     0,     7,     7,    31,   -42,   -42,   -42,   -42,
     -42,   -42,   -42,    20,    20,   104,     7,     7,     7,   -42,
     -42,   -42,    19,   -42,   -42,   179,   194,   -42,   166,   -42,
      30,   -42,   -42,   111,   -42,   -42,    26,   -42,   -42,    12,
     -42,     7,   -42,   -42,   -42,    48,   134,   149,   173,   -42,
     104,   -42,   -42,   -42,   -42,   -42,    29,   114,   -42,   -42,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,   118,   118,   118,   118,   118,   118,   118,   118,
     118,     7,     7,     7,     7,     7,     7,     7,     7,    37,
      26,    47,    32,    65,   -42,   -42,    32,   -42,   -42,   -42,
     -42,    -5,    39,    20,    20,   -42,    12,    20,    20,     4,
       4,   200,   200,   200,   200,   200,   200,   112,   112,    36,
      36,    36,   -42,   118,   118,   206,   206,   206,   206,   -20,
     -20,    43,    43,   -42,   -42,    12,    12,    12,    12,    12,
      12,    12,   117,   -42,   -42,   111,   111,   -42,   108,    99,
     -42,    -4,     7,   107,   -42,   -42,   -42,   135,   136,   -42,
       7,   -42
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -41,   113,   -42,   -42,   -42,   -42,    -1,   -13,   -42,    21,
     -42,   -42,    54,   -42,   -42,   -42,   -12,   -42,   -42,   -42,
     -42,    23,   -17,   -42,    -6,   110
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -35
static const yytype_int16 yytable[] =
{
      52,    53,   100,    38,    40,   108,    57,    50,    62,    19,
      16,    55,    59,   119,    21,    22,    51,    58,    38,    88,
      89,    90,    65,    17,    18,    19,    20,    21,    22,    23,
      91,    76,    77,    78,    79,    80,    81,   102,    54,    67,
     120,    99,   110,   112,   152,   106,    56,    27,    61,   109,
      91,    28,    68,    69,   113,    24,    25,   153,   107,   104,
     105,   116,    26,    27,    28,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   154,    86,    87,    81,    88,    89,
      90,    68,    69,   111,    90,   144,   145,   146,   147,   148,
     149,   150,   151,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   159,   160,    38,    38,    19,
      20,    38,    38,    60,   163,   164,   112,    62,    21,    22,
      43,    21,    22,    51,    20,   -34,    44,   133,     1,     2,
     165,     3,     4,    69,     5,   114,    63,    64,     6,     7,
      25,   105,   111,    61,   108,   169,    26,    27,   170,   168,
      78,    79,    80,    81,   134,    28,   101,   168,    28,   109,
      26,    70,    71,    72,    73,    74,    75,   157,   158,   171,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
       0,     0,   166,   110,    91,    86,    87,     0,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    92,
      93,    94,    95,    96,    97,    98,    70,    71,    72,    73,
      74,    75,     0,     0,     0,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,     0,     0,     0,     0,     0,
      86,    87,     0,    88,    89,    90,    76,    77,    78,    79,
      80,    81,    86,    87,     0,    88,    89,    90
};

static const yytype_int16 yycheck[] =
{
      13,    14,    43,     9,     8,    10,    23,     7,    25,     5,
       0,    23,    24,     9,     7,     8,     9,    23,    24,    39,
      40,    41,    28,     3,     4,     5,     6,     7,     8,     9,
      18,    36,    37,    38,    39,    40,    41,    43,     7,    20,
      36,    11,    10,    60,     7,    51,    23,    43,    25,    10,
      18,    44,    33,    34,    25,    35,    36,    10,    10,    33,
      34,    67,    42,    43,    44,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     9,    36,    37,    41,    39,    40,
      41,    33,    34,    60,    41,    91,    92,    93,    94,    95,
      96,    97,    98,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,   117,   118,   113,   114,     5,
       6,   117,   118,     9,   155,   156,   133,   134,     7,     8,
       9,     7,     8,     9,     6,     8,    15,     9,    13,    14,
      22,    16,    17,    34,    19,    21,    26,    27,    23,    24,
      36,    34,   119,   120,    10,    10,    42,    43,    12,   162,
      38,    39,    40,    41,    36,    44,    43,   170,    44,    10,
      42,    27,    28,    29,    30,    31,    32,   113,   114,   170,
      36,    37,    38,    39,    40,    41,    27,    28,    29,    30,
      -1,    -1,   161,    10,    18,    36,    37,    -1,    39,    40,
      41,    18,    26,    27,    28,    29,    30,    31,    32,    26,
      27,    28,    29,    30,    31,    32,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    36,    37,    38,    39,    40,
      41,    27,    28,    29,    30,    -1,    -1,    -1,    -1,    -1,
      36,    37,    -1,    39,    40,    41,    36,    37,    38,    39,
      40,    41,    36,    37,    -1,    39,    40,    41
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    13,    14,    16,    17,    19,    23,    24,    47,    49,
      48,    50,    53,    51,    52,    54,     0,     3,     4,     5,
       6,     7,     8,     9,    35,    36,    42,    43,    44,    67,
      68,    70,    72,    75,    76,    77,    78,    79,    80,    81,
       8,    64,    65,     9,    15,    55,    56,    57,    63,    80,
       7,     9,    63,    63,     7,    72,    77,    78,    80,    72,
       9,    77,    78,    81,    81,    80,    69,    20,    33,    34,
      27,    28,    29,    30,    31,    32,    36,    37,    38,    39,
      40,    41,    27,    28,    29,    30,    36,    37,    39,    40,
      41,    18,    26,    27,    28,    29,    30,    31,    32,    11,
      56,    57,    80,    60,    33,    34,    80,    10,    10,    10,
      10,    77,    78,    25,    21,    71,    80,    74,    73,     9,
      36,    77,    77,    77,    77,    77,    77,    77,    77,    77,
      77,    77,    77,     9,    36,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    80,    80,    80,    80,    80,    80,
      80,    80,     7,    10,     9,    59,    58,    68,    68,    72,
      72,    66,    61,    56,    56,    22,    65,    62,    63,    10,
      12,    62
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 76 "keynote.y"
    { keynote_exceptionflag = keynote_donteval = 0; }
    break;

  case 4:
#line 78 "keynote.y"
    { keynote_exceptionflag = keynote_donteval = 0; }
    break;

  case 6:
#line 79 "keynote.y"
    { keynote_exceptionflag = keynote_donteval = 0; }
    break;

  case 8:
#line 81 "keynote.y"
    { keynote_exceptionflag = keynote_donteval = 0; }
    break;

  case 10:
#line 82 "keynote.y"
    { keynote_exceptionflag = keynote_donteval = 0; }
    break;

  case 12:
#line 84 "keynote.y"
    { keynote_exceptionflag = keynote_donteval = 0; }
    break;

  case 13:
#line 85 "keynote.y"
    { keynote_lex_remove((yyvsp[(3) - (3)].string));
				 if (strcmp((yyvsp[(3) - (3)].string), KEYNOTE_VERSION_STRING))
				   keynote_errno = ERROR_SYNTAX;
				 free((yyvsp[(3) - (3)].string));
			       }
    break;

  case 14:
#line 90 "keynote.y"
    { keynote_exceptionflag = keynote_donteval = 0; }
    break;

  case 15:
#line 91 "keynote.y"
    { keynote_lex_remove((yyvsp[(3) - (3)].string));
			         keynote_privkey = (yyvsp[(3) - (3)].string);
			       }
    break;

  case 16:
#line 96 "keynote.y"
    { keynote_returnvalue = 0;
                                return 0; 
                              }
    break;

  case 17:
#line 99 "keynote.y"
    { keynote_returnvalue = (yyvsp[(1) - (1)].intval);
				return 0;
                              }
    break;

  case 18:
#line 104 "keynote.y"
    { (yyval.intval) = (yyvsp[(1) - (1)].intval); }
    break;

  case 19:
#line 105 "keynote.y"
    { (yyval.intval) = (yyvsp[(1) - (1)].intval); }
    break;

  case 20:
#line 108 "keynote.y"
    { if (((yyvsp[(1) - (2)].intval) == 0) && !keynote_justrecord)
                                     keynote_donteval = 1;
                                 }
    break;

  case 21:
#line 111 "keynote.y"
    { if ((yyvsp[(1) - (4)].intval) > (yyvsp[(4) - (4)].intval))
		     (yyval.intval) = (yyvsp[(4) - (4)].intval);
		   else
	       	     (yyval.intval) = (yyvsp[(1) - (4)].intval);
		   keynote_donteval = 0;
                 }
    break;

  case 22:
#line 117 "keynote.y"
    { if (((yyvsp[(1) - (2)].intval) == (keynote_current_session->ks_values_num - 1)) && !keynote_justrecord)
	                             keynote_donteval = 1;
       	                         }
    break;

  case 23:
#line 120 "keynote.y"
    { if ((yyvsp[(1) - (4)].intval) >= (yyvsp[(4) - (4)].intval))
		     (yyval.intval) = (yyvsp[(1) - (4)].intval);
		   else
		     (yyval.intval) = (yyvsp[(4) - (4)].intval);
		   keynote_donteval = 0;
                 }
    break;

  case 24:
#line 126 "keynote.y"
    { (yyval.intval) = (yyvsp[(2) - (3)].intval); }
    break;

  case 25:
#line 127 "keynote.y"
    { keylistcount = 0; }
    break;

  case 26:
#line 127 "keynote.y"
    {
			 if (!keynote_justrecord && !keynote_donteval)
 	                   if (keynote_init_kth() == -1)
			     return -1;
                       }
    break;

  case 27:
#line 132 "keynote.y"
    {
			      if (keylistcount < (yyvsp[(1) - (6)].intval))
			      {
				  keynote_errno = ERROR_SYNTAX;
				  return -1;
			      }

			    if (!keynote_justrecord && !keynote_donteval)
			      (yyval.intval) = get_kth((yyvsp[(1) - (6)].intval));
			    else
			      (yyval.intval) = 0;
			  }
    break;

  case 28:
#line 147 "keynote.y"
    { /* Don't do anything if we're just recording */ 
              if (!keynote_justrecord && !keynote_donteval)
		if (((yyvsp[(1) - (1)].intval) < keynote_current_session->ks_values_num) && ((yyvsp[(1) - (1)].intval) >= 0))
		  keynote_kth_array[(yyvsp[(1) - (1)].intval)]++;

	      keylistcount++;
            }
    break;

  case 29:
#line 155 "keynote.y"
    { /* Don't do anything if we're just recording */ 
	      if (!keynote_justrecord && !keynote_donteval)
		if (((yyvsp[(1) - (3)].intval) < keynote_current_session->ks_values_num) && ((yyvsp[(1) - (3)].intval) >= 0))
		  keynote_kth_array[(yyvsp[(1) - (3)].intval)]++;

	      keylistcount++;
            }
    break;

  case 30:
#line 164 "keynote.y"
    {
		   if (keynote_donteval)
		     (yyval.intval) = 0;
		   else
		   {
		       keynote_lex_remove((yyvsp[(1) - (1)].string));
		       if (keynote_justrecord)
		       {
			   if (keynote_keylist_add(&keynote_keypred_keylist,
						   (yyvsp[(1) - (1)].string)) == -1)
			   {
			       free((yyvsp[(1) - (1)].string));
			       return -1;
			   }

			   (yyval.intval) = 0;
		       }
		       else
			 switch (keynote_in_action_authorizers((yyvsp[(1) - (1)].string), KEYNOTE_ALGORITHM_UNSPEC))
			 {
			     case -1:
				 free((yyvsp[(1) - (1)].string));
				 return -1;
				 
			     case RESULT_TRUE:
				 free((yyvsp[(1) - (1)].string));
				 (yyval.intval) = keynote_current_session->ks_values_num -
				      1;
				 break;
				 
			     default:
				 (yyval.intval) = resolve_assertion((yyvsp[(1) - (1)].string));
				 free((yyvsp[(1) - (1)].string));
				 break;
			 }
		   }
                 }
    break;

  case 33:
#line 208 "keynote.y"
    {
            int i;

            keynote_lex_remove((yyvsp[(1) - (3)].string));
	    keynote_lex_remove((yyvsp[(3) - (3)].string));
 
	    /*
	     * Variable names starting with underscores are illegal here.
	     */
	    if ((yyvsp[(1) - (3)].string)[0] == '_')
	    {
		free((yyvsp[(1) - (3)].string));
		free((yyvsp[(3) - (3)].string));
		keynote_errno = ERROR_SYNTAX;
		return -1;
	    }
	    
	    /* If the identifier already exists, report error. */
	    if (keynote_env_lookup((yyvsp[(1) - (3)].string), &keynote_init_list, 1) != (char *) NULL)
	    {
		free((yyvsp[(1) - (3)].string));
		free((yyvsp[(3) - (3)].string));
		keynote_errno = ERROR_SYNTAX;
		return -1;
	    }

	    i = keynote_env_add((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string), &keynote_init_list, 1, 0);
	    free((yyvsp[(1) - (3)].string));
	    free((yyvsp[(3) - (3)].string));

	    if (i != RESULT_TRUE)
	      return -1;
	  }
    break;

  case 34:
#line 242 "keynote.y"
    {
            int i;

	    keynote_lex_remove((yyvsp[(1) - (3)].string));
	    keynote_lex_remove((yyvsp[(3) - (3)].string));

	    /*
	     * Variable names starting with underscores are illegal here.
	     */
	    if ((yyvsp[(1) - (3)].string)[0] == '_')
	    {
		free((yyvsp[(1) - (3)].string));
		free((yyvsp[(3) - (3)].string));
		keynote_errno = ERROR_SYNTAX;
		return -1;
	    }
	 
	    /* If the identifier already exists, report error. */
	    if (keynote_env_lookup((yyvsp[(1) - (3)].string), &keynote_init_list, 1) != (char *) NULL)
	    {
		free((yyvsp[(1) - (3)].string));
		free((yyvsp[(3) - (3)].string));
		keynote_errno = ERROR_SYNTAX;
		return -1;
	    }

	    i = keynote_env_add((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string), &keynote_init_list, 1, 0);
	    free((yyvsp[(1) - (3)].string));
	    free((yyvsp[(3) - (3)].string));

	    if (i != RESULT_TRUE)
	      return -1;
	  }
    break;

  case 36:
#line 277 "keynote.y"
    { 
	        keynote_returnvalue = (yyvsp[(1) - (1)].intval);
		return 0;
	      }
    break;

  case 37:
#line 283 "keynote.y"
    { (yyval.intval) = 0; }
    break;

  case 38:
#line 284 "keynote.y"
    {
			  /* 
			   * Cleanup envlist of additions such as 
			   * regexp results
			   */
			  keynote_env_cleanup(&keynote_temp_list, 1);
                    }
    break;

  case 39:
#line 291 "keynote.y"
    {
		      if ((yyvsp[(1) - (4)].intval) > (yyvsp[(4) - (4)].intval))
			(yyval.intval) = (yyvsp[(1) - (4)].intval);
		      else
			(yyval.intval) = (yyvsp[(4) - (4)].intval);
                    }
    break;

  case 40:
#line 300 "keynote.y"
    {
		if (checkexception((yyvsp[(1) - (3)].bool)))
		  (yyval.intval) = (yyvsp[(3) - (3)].intval);
		else
		  (yyval.intval) = 0;
	      }
    break;

  case 41:
#line 307 "keynote.y"
    {
		if (checkexception((yyvsp[(1) - (1)].bool)))
		  (yyval.intval) = keynote_current_session->ks_values_num - 1;
		else
		  (yyval.intval) = 0;
	      }
    break;

  case 42:
#line 315 "keynote.y"
    {  if (keynote_exceptionflag || keynote_donteval)
		    (yyval.intval) = 0;
		  else
		  {
		      keynote_lex_remove((yyvsp[(1) - (1)].string));

		      (yyval.intval) = keynote_retindex((yyvsp[(1) - (1)].string));
		      if ((yyval.intval) == -1)   /* Invalid return value */
			(yyval.intval) = 0;

		      free((yyvsp[(1) - (1)].string));
		  }
                }
    break;

  case 43:
#line 328 "keynote.y"
    { (yyval.intval) = (yyvsp[(2) - (3)].intval); }
    break;

  case 44:
#line 331 "keynote.y"
    { (yyval.bool) = (yyvsp[(2) - (3)].bool); }
    break;

  case 45:
#line 332 "keynote.y"
    { if ((yyvsp[(1) - (2)].bool) == 0)
	               keynote_donteval = 1;
	           }
    break;

  case 46:
#line 334 "keynote.y"
    { (yyval.bool) = ((yyvsp[(1) - (4)].bool) && (yyvsp[(4) - (4)].bool));
		                          keynote_donteval = 0;
		                        }
    break;

  case 47:
#line 337 "keynote.y"
    { if ((yyvsp[(1) - (2)].bool))
	              keynote_donteval = 1; 
	          }
    break;

  case 48:
#line 339 "keynote.y"
    { (yyval.bool) = ((yyvsp[(1) - (4)].bool) || (yyvsp[(4) - (4)].bool));
		                          keynote_donteval = 0;
                                        }
    break;

  case 49:
#line 342 "keynote.y"
    { (yyval.bool) = !((yyvsp[(2) - (2)].bool)); }
    break;

  case 50:
#line 343 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (1)].bool); }
    break;

  case 51:
#line 344 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (1)].bool); }
    break;

  case 52:
#line 345 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (1)].bool); }
    break;

  case 53:
#line 346 "keynote.y"
    { (yyval.bool) = 1; }
    break;

  case 54:
#line 347 "keynote.y"
    { (yyval.bool) = 0; }
    break;

  case 55:
#line 350 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].intval) < (yyvsp[(3) - (3)].intval); }
    break;

  case 56:
#line 351 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].intval) > (yyvsp[(3) - (3)].intval); }
    break;

  case 57:
#line 352 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].intval) == (yyvsp[(3) - (3)].intval); }
    break;

  case 58:
#line 353 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].intval) <= (yyvsp[(3) - (3)].intval); }
    break;

  case 59:
#line 354 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].intval) >= (yyvsp[(3) - (3)].intval); }
    break;

  case 60:
#line 355 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].intval) != (yyvsp[(3) - (3)].intval); }
    break;

  case 61:
#line 358 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].doubval) < (yyvsp[(3) - (3)].doubval); }
    break;

  case 62:
#line 359 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].doubval) > (yyvsp[(3) - (3)].doubval); }
    break;

  case 63:
#line 360 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].doubval) <= (yyvsp[(3) - (3)].doubval); }
    break;

  case 64:
#line 361 "keynote.y"
    { (yyval.bool) = (yyvsp[(1) - (3)].doubval) >= (yyvsp[(3) - (3)].doubval); }
    break;

  case 65:
#line 364 "keynote.y"
    { (yyval.intval) = (yyvsp[(1) - (3)].intval) + (yyvsp[(3) - (3)].intval); }
    break;

  case 66:
#line 365 "keynote.y"
    { (yyval.intval) = (yyvsp[(1) - (3)].intval) - (yyvsp[(3) - (3)].intval); }
    break;

  case 67:
#line 366 "keynote.y"
    { (yyval.intval) = (yyvsp[(1) - (3)].intval) * (yyvsp[(3) - (3)].intval); }
    break;

  case 68:
#line 367 "keynote.y"
    { if ((yyvsp[(3) - (3)].intval) == 0)
	                      {
				  if (!keynote_donteval)
				    keynote_exceptionflag = 1;
			      }
	                      else
			        (yyval.intval) = ((yyvsp[(1) - (3)].intval) / (yyvsp[(3) - (3)].intval));
			    }
    break;

  case 69:
#line 375 "keynote.y"
    { if ((yyvsp[(3) - (3)].intval) == 0)
	                      {
				  if (!keynote_donteval)
				    keynote_exceptionflag = 1;
			      }
	                      else
			        (yyval.intval) = (yyvsp[(1) - (3)].intval) % (yyvsp[(3) - (3)].intval);
			    }
    break;

  case 70:
#line 383 "keynote.y"
    { (yyval.intval) = intpow((yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval)); }
    break;

  case 71:
#line 384 "keynote.y"
    { (yyval.intval) = -((yyvsp[(2) - (2)].intval)); }
    break;

  case 72:
#line 385 "keynote.y"
    { (yyval.intval) = (yyvsp[(2) - (3)].intval); }
    break;

  case 73:
#line 386 "keynote.y"
    { (yyval.intval) = (yyvsp[(1) - (1)].intval); }
    break;

  case 74:
#line 387 "keynote.y"
    { if (keynote_exceptionflag ||
					      keynote_donteval)
	                                    (yyval.intval) = 0;
 	                                  else
					  {
					      keynote_lex_remove((yyvsp[(2) - (2)].string));

					      if (!isfloatstring((yyvsp[(2) - (2)].string)))
						(yyval.intval) = 0;
					      else
						(yyval.intval) = (int) floor(atof((yyvsp[(2) - (2)].string)));
					      free((yyvsp[(2) - (2)].string));
					  }
					}
    break;

  case 75:
#line 403 "keynote.y"
    { (yyval.doubval) = ((yyvsp[(1) - (3)].doubval) + (yyvsp[(3) - (3)].doubval)); }
    break;

  case 76:
#line 404 "keynote.y"
    { (yyval.doubval) = ((yyvsp[(1) - (3)].doubval) - (yyvsp[(3) - (3)].doubval)); }
    break;

  case 77:
#line 405 "keynote.y"
    { (yyval.doubval) = ((yyvsp[(1) - (3)].doubval) * (yyvsp[(3) - (3)].doubval)); }
    break;

  case 78:
#line 406 "keynote.y"
    { if ((yyvsp[(3) - (3)].doubval) == 0)
	                                  {
					      if (!keynote_donteval)
						keynote_exceptionflag = 1;
					  }
	                                  else
			        	   (yyval.doubval) = ((yyvsp[(1) - (3)].doubval) / (yyvsp[(3) - (3)].doubval));
					}
    break;

  case 79:
#line 414 "keynote.y"
    { if (!keynote_exceptionflag &&
						      !keynote_donteval)
	                                            (yyval.doubval) = pow((yyvsp[(1) - (3)].doubval), (yyvsp[(3) - (3)].doubval));
	                                        }
    break;

  case 80:
#line 418 "keynote.y"
    { (yyval.doubval) = -((yyvsp[(2) - (2)].doubval)); }
    break;

  case 81:
#line 419 "keynote.y"
    { (yyval.doubval) = (yyvsp[(2) - (3)].doubval); }
    break;

  case 82:
#line 420 "keynote.y"
    { (yyval.doubval) = (yyvsp[(1) - (1)].doubval); }
    break;

  case 83:
#line 421 "keynote.y"
    {
	                                  if (keynote_exceptionflag ||
					      keynote_donteval)
					    (yyval.doubval) = 0.0;
					  else
					  {
					      keynote_lex_remove((yyvsp[(2) - (2)].string));
					  
					      if (!isfloatstring((yyvsp[(2) - (2)].string)))
						(yyval.doubval) = 0.0;
					      else
						(yyval.doubval) = atof((yyvsp[(2) - (2)].string));
					      free((yyvsp[(2) - (2)].string));
					  }
	                                }
    break;

  case 84:
#line 438 "keynote.y"
    {
                        if (keynote_exceptionflag || keynote_donteval)
			  (yyval.bool) = 0;
			else
			{
			    (yyval.bool) = strcmp((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)) == 0 ? 1 : 0;
			    keynote_lex_remove((yyvsp[(1) - (3)].string));
			    keynote_lex_remove((yyvsp[(3) - (3)].string));
			    free((yyvsp[(1) - (3)].string));
			    free((yyvsp[(3) - (3)].string));
			}
		      }
    break;

  case 85:
#line 450 "keynote.y"
    {
	                if (keynote_exceptionflag || keynote_donteval)
			  (yyval.bool) = 0;
			else
			{
			    (yyval.bool) = strcmp((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)) != 0 ? 1 : 0;
			    keynote_lex_remove((yyvsp[(1) - (3)].string));
			    keynote_lex_remove((yyvsp[(3) - (3)].string));
			    free((yyvsp[(1) - (3)].string));
			    free((yyvsp[(3) - (3)].string));
			}
		      }
    break;

  case 86:
#line 462 "keynote.y"
    {
	                if (keynote_exceptionflag || keynote_donteval)
			  (yyval.bool) = 0;
			else
			{
			    (yyval.bool) = strcmp((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)) < 0 ? 1 : 0;
			    keynote_lex_remove((yyvsp[(1) - (3)].string));
			    keynote_lex_remove((yyvsp[(3) - (3)].string));
			    free((yyvsp[(1) - (3)].string));
			    free((yyvsp[(3) - (3)].string));
			}
		      }
    break;

  case 87:
#line 474 "keynote.y"
    {
	                if (keynote_exceptionflag || keynote_donteval)
			  (yyval.bool) = 0;
			else
			{
			    (yyval.bool) = strcmp((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)) > 0 ? 1 : 0;
			    keynote_lex_remove((yyvsp[(1) - (3)].string));
			    keynote_lex_remove((yyvsp[(3) - (3)].string));
			    free((yyvsp[(1) - (3)].string));
			    free((yyvsp[(3) - (3)].string));
			}
		      }
    break;

  case 88:
#line 486 "keynote.y"
    {
	                if (keynote_exceptionflag || keynote_donteval)
			  (yyval.bool) = 0;
			else
			{
			    (yyval.bool) = strcmp((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)) <= 0 ? 1 : 0;
			    keynote_lex_remove((yyvsp[(1) - (3)].string));
			    keynote_lex_remove((yyvsp[(3) - (3)].string));
			    free((yyvsp[(1) - (3)].string));
			    free((yyvsp[(3) - (3)].string));
			}
		      }
    break;

  case 89:
#line 498 "keynote.y"
    {
	                if (keynote_exceptionflag || keynote_donteval)
			  (yyval.bool) = 0;
			else
			{
			    (yyval.bool) = strcmp((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string)) >= 0 ? 1 : 0;
			    keynote_lex_remove((yyvsp[(1) - (3)].string));
			    keynote_lex_remove((yyvsp[(3) - (3)].string));
			    free((yyvsp[(1) - (3)].string));
			    free((yyvsp[(3) - (3)].string));
			}
		      }
    break;

  case 90:
#line 511 "keynote.y"
    {
	      regmatch_t pmatch[32];
	      char grp[4], *gr;
	      regex_t preg;
	      int i;

	      if (keynote_exceptionflag || keynote_donteval)
		(yyval.bool) = 0;
	      else
	      {
		  keynote_lex_remove((yyvsp[(1) - (3)].string));
		  keynote_lex_remove((yyvsp[(3) - (3)].string));

		  memset(pmatch, 0, sizeof(pmatch));
		  memset(grp, 0, sizeof(grp));

#if HAVE_REGCOMP
		  if (regcomp(&preg, (yyvsp[(3) - (3)].string), REG_EXTENDED))
		  {
#else /* HAVE_REGCOMP */
#error "This system does not have regcomp()."
#endif /* HAVE_REGCOMP */
		      free((yyvsp[(1) - (3)].string));
		      free((yyvsp[(3) - (3)].string));
		      keynote_exceptionflag = 1;
		  }
		  else
		  {
		      /* Clean-up residuals from previous regexps */
		      keynote_env_cleanup(&keynote_temp_list, 1);

		      free((yyvsp[(3) - (3)].string));
		      i = regexec(&preg, (yyvsp[(1) - (3)].string), 32, pmatch, 0);
		      (yyval.bool) = (i == 0 ? 1 : 0);
		      if (i == 0)
		      {
#if !defined(HAVE_SNPRINTF)
			  sprintf(grp, "%d", preg.re_nsub);
#else /* !HAVE_SNPRINTF */
			  snprintf(grp, 3, "%d", preg.re_nsub);
#endif /* !HAVE_SNPRINTF */
			  if (keynote_env_add("_0", grp, &keynote_temp_list,
					      1, 0) != RESULT_TRUE)
			  {
			      free((yyvsp[(1) - (3)].string));
			      regfree(&preg);
			      return -1;
			  }

			  for (i = 1; i < 32 && pmatch[i].rm_so != -1; i++)
			  {
			      gr = calloc(pmatch[i].rm_eo - pmatch[i].rm_so +
					  1, sizeof(char));
			      if (gr == (char *) NULL)
			      {
				  free((yyvsp[(1) - (3)].string));
				  regfree(&preg);
				  keynote_errno = ERROR_MEMORY;
				  return -1;
			      }

			      strncpy(gr, (yyvsp[(1) - (3)].string) + pmatch[i].rm_so,
				      pmatch[i].rm_eo - pmatch[i].rm_so);
			      gr[pmatch[i].rm_eo - pmatch[i].rm_so] = '\0';
#if !defined(HAVE_SNPRINTF)
			      sprintf(grp, "_%d", i);
#else /* !HAVE_SNPRINTF */
			      snprintf(grp, 3, "_%d", i);
#endif /* !HAVE_SNPRINTF */
			      if (keynote_env_add(grp, gr, &keynote_temp_list,
						  1, 0) == -1)
			      {
				  free((yyvsp[(1) - (3)].string));
				  regfree(&preg);
				  free(gr);
				  return -1;
			      }
			      else
				free(gr);
			  }
		      }

		      regfree(&preg);
		      free((yyvsp[(1) - (3)].string));
		  }
	      }
	    }
    break;

  case 91:
#line 600 "keynote.y"
    {  if (keynote_exceptionflag || keynote_donteval)
			  (yyval.string) = (char *) NULL;
			else
			{
			    (yyval.string) = calloc(strlen((yyvsp[(1) - (3)].string)) + strlen((yyvsp[(3) - (3)].string)) + 1,
					sizeof(char));
			    keynote_lex_remove((yyvsp[(1) - (3)].string));
			    keynote_lex_remove((yyvsp[(3) - (3)].string));
			    if ((yyval.string) == (char *) NULL)
			    {
				free((yyvsp[(1) - (3)].string));
				free((yyvsp[(3) - (3)].string));
				keynote_errno = ERROR_MEMORY;
				return -1;
			    }
 
			    strcpy((yyval.string), (yyvsp[(1) - (3)].string));
			    strcpy((yyval.string) + strlen((yyvsp[(1) - (3)].string)), (yyvsp[(3) - (3)].string));
			    free((yyvsp[(1) - (3)].string));
			    free((yyvsp[(3) - (3)].string));
			    if (keynote_lex_add((yyval.string), LEXTYPE_CHAR) == -1)
			      return -1;
			}
		      }
    break;

  case 92:
#line 624 "keynote.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 93:
#line 627 "keynote.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 94:
#line 628 "keynote.y"
    { (yyval.string) = (yyvsp[(2) - (3)].string); }
    break;

  case 95:
#line 629 "keynote.y"
    {  if (keynote_exceptionflag || keynote_donteval)
	                     (yyval.string) = (char *) NULL;
 	                   else
			   {
			       (yyval.string) = my_lookup((yyvsp[(1) - (1)].string));
			       keynote_lex_remove((yyvsp[(1) - (1)].string));
			       free((yyvsp[(1) - (1)].string));
			       if ((yyval.string) == (char *) NULL)
			       {
				   if (keynote_errno)
				     return -1;
				   (yyval.string) = strdup("");
			       }
			       else
				 (yyval.string) = strdup((yyval.string));

			       if ((yyval.string) == (char *) NULL)
			       {
				   keynote_errno = ERROR_MEMORY;
				   return -1;
			       }

			       if (keynote_lex_add((yyval.string), LEXTYPE_CHAR) == -1)
				 return -1;
			   }
	                 }
    break;

  case 96:
#line 655 "keynote.y"
    {  if (keynote_exceptionflag || keynote_donteval)
			      (yyval.string) = (char *) NULL;
			    else
			    {
				(yyval.string) = my_lookup((yyvsp[(2) - (2)].string));
				keynote_lex_remove((yyvsp[(2) - (2)].string));
				free((yyvsp[(2) - (2)].string));
				if ((yyval.string) == (char *) NULL)
				{
				    if (keynote_errno)
				      return -1;
				    (yyval.string) = strdup("");
				}
				else
				  (yyval.string) = strdup((yyval.string));

				if ((yyval.string) == (char *) NULL)
				{
				    keynote_errno = ERROR_MEMORY;
				    return -1;
				}

				if (keynote_lex_add((yyval.string), LEXTYPE_CHAR) == -1)
				  return -1;
			    }
			 }
    break;


/* Line 1267 of yacc.c.  */
#line 2519 "k.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 682 "keynote.y"


/*
 * Find all assertions signed by s and give us the one with the highest
 * return value.
 */
static int
resolve_assertion(char *s)
{
    int i, alg = KEYNOTE_ALGORITHM_NONE, p = 0;
    void *key = (void *) s;
    struct assertion *as;
    struct keylist *kl;

    kl = keynote_keylist_find(keynote_current_assertion->as_keylist, s);
    if (kl != (struct keylist *) NULL)
    {
	alg = kl->key_alg;
	key = kl->key_key;
    }

    for (i = 0;; i++)
    {
	as = keynote_find_assertion(key, i, alg);
	if (as == (struct assertion *) NULL)  /* Gone through all of them */
	  return p;

	if (as->as_kresult == KRESULT_DONE)
	  if (p < as->as_result)
	    p = as->as_result;

	/* Short circuit if we find an assertion with maximum return value */
	if (p == (keynote_current_session->ks_values_num - 1))
	  return p;
    }

    return 0;
}

/* 
 * Environment variable lookup. 
 */
static char *
my_lookup(char *s)
{
    struct keynote_session *ks = keynote_current_session;
    char *ret;

    if (!strcmp(s, "_MIN_TRUST"))
    {
	keynote_used_variable = 1;
	return ks->ks_values[0];
    }
    else
    {
	if (!strcmp(s, "_MAX_TRUST"))
	{
	    keynote_used_variable = 1;
	    return ks->ks_values[ks->ks_values_num - 1];
	}
	else
	{
	    if (!strcmp(s, "_VALUES"))
	    {
		keynote_used_variable = 1;
		return keynote_env_lookup("_VALUES", ks->ks_env_table,
					  HASHTABLESIZE);
	    }
	    else
	    {
		if (!strcmp(s, "_ACTION_AUTHORIZERS"))
		{
		    keynote_used_variable = 1;
		    return keynote_env_lookup("_ACTION_AUTHORIZERS",
					      ks->ks_env_table, HASHTABLESIZE);
		}
	    }
	}
    }

    /* Temporary list (regexp results) */
    ret = keynote_env_lookup(s, &keynote_temp_list, 1);
    if (ret != (char *) NULL)
      return ret;
    else
      if (keynote_errno != 0)
	return (char *) NULL;

    /* Local-Constants */
    ret = keynote_env_lookup(s, &keynote_init_list, 1);
    if (ret != (char *) NULL)
      return ret;
    else
      if (keynote_errno != 0)
	return (char *) NULL;

    keynote_used_variable = 1;

    /* Action environment */
    ret = keynote_env_lookup(s, ks->ks_env_table, HASHTABLESIZE);
    if (ret != (char *) NULL)
      return ret;
    else
      if (keynote_errno != 0)
	return (char *) NULL;

    /* Regex table */
    return keynote_env_lookup(s, &(ks->ks_env_regex), 1);
}

/*
 * If we had an exception, the boolean expression should return false.
 * Otherwise, return the result of the expression (the argument).
 */
static int
checkexception(int i)
{
    if (keynote_exceptionflag)
    {
	keynote_exceptionflag = 0;
	return 0;
    }
    else
      return i;
}


/* 
 * Integer exponentation -- copied from Schneier's AC2, page 244. 
 */
static int
intpow(int x, int y)
{
    int s = 1;
    
    /* 
     * x^y with y < 0 is equivalent to 1/(x^y), which for
     * integer arithmetic is 0.
     */
    if (y < 0)
      return 0;

    while (y)
    {
	if (y & 1)
	  s *= x;
	
	y >>= 1;
	x *= x;
    }

    return s;
}

/* 
 * Check whether the string is a floating point number. 
 */
static int
isfloatstring(char *s)
{
    int i, point = 0;
    
    for (i = strlen(s) - 1; i >= 0; i--)
      if (!isdigit((int) s[i]))
      {
	  if (s[i] == '.')
	  {
	      if (point == 1)
	        return 0;
	      else
	        point = 1;
	  }
	  else
	    if (i==0 && s[i]=='-')
	      return 1;
	    else
	      return 0;
      }

    return 1;
}

/*
 * Initialize array for threshold search.
 */
static int
keynote_init_kth(void)
{
    int i = keynote_current_session->ks_values_num;
    
    if (i == -1)
      return -1;
    
    keynote_kth_array = (int *) calloc(i, sizeof(int));
    if (keynote_kth_array == (int *) NULL)
    {
	keynote_errno = ERROR_MEMORY;
	return -1;
    }

    return RESULT_TRUE;
}

/*
 * Get the k-th best return value.
 */
static int
get_kth(int k)
{
    int i;

    for (i = keynote_current_session->ks_values_num - 1; i >= 0; i--)
    {
	k -= keynote_kth_array[i];
	
	if (k <= 0)
	  return i;
    }

    return 0;
}

/*
 * Cleanup array.
 */
void
keynote_cleanup_kth(void)
{
    if (keynote_kth_array != (int *) NULL)
    {
	free(keynote_kth_array);
	keynote_kth_array = (int *) NULL;
    }
}

void
knerror(char *s)
{}

